
;*******************************************************************************
;				FM_3_SSD1306.asm
;	 FM-   RDA5807M  LCD- SSD1306 (12864 ).
;	   ATMEGA8    .  8 .
; 		  :
;-*-  3-    GPD2856C.   
;-*-   3-      CH-.
;-*-    FM-  3-     CH-.
;-*-  ,         , 
;             CH+  CH-.
;-*-           
;            CH+.
;-*-        .
;-*-       .
;-*-         EEPROM  
;-*-   .       
;-*-     . 
;-*-    V+  V-.
;-*-        0  16.
;-*-       .
;-*-  "-"   ,   .
;
;  :
; PB0 - 
; PB1 -  Next/V++ 	(V+)
; PB2 -  Prev/V-- 	(V-)
; PB3 -      3-
; PB4 -  P/P/Mode				(+)
; PB5 -  Repeat				(-)
;
; PC4 - (SDA) -    IIC
; PC5 - (SCL) -    IIC
;
; PD7 - .   -
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
	#define F_CPU (8000000) ; 
  	;   
  	.def fnt_d = R6			; 
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		; 
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
	.equ Tm_l  = 2			;   2*8=16 .
	
;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
	str_num: .byte 1		;   Y
	poz_num: .byte 1  		;    X
	
;=============================================================================
	.ESEG					;   EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 

;===============================  =====================================
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
	 	tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
		
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_Y					;
		ldi temp,@1					;   
		rcall lcd_X					;
	.ENDMACRO						;: POZ_LCD 12,5
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	reti 				; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	

;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
			;  B
	 	ldi temp,0b00001000			;    
		out DDRB,temp   			;
		ldi temp,0b11110111			;  
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;  
		out PORTC,temp   			;
		
			;  D
	 	ldi temp,0b11010000			;   D
		out DDRD,temp				;
		ldi temp,0b00001111			;
		out PORTD,temp				;
		
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;
		ldi temp,(1<<TOIE1)|(1<<TOIE0)	; .  1  0
		out TIMSK,temp				;
		ldi temp,0b00000101			; 
		out TCCR0,temp				;  0   1/1024
		out TCCR1B,temp				;  1   1/1024
		
		sei                         ;  
		
;===================   ==================================
		; 
		rcall IIC_init				;  I2C
		rcall lcd_init				; LCD 
		clr fnt_d					;   
		inc fnt_d					;  
ms_dspl:		;    
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				; .
		;  RDA5807
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;     EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rcall type_vol				;    LCD
		DELAY 20					; 656 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		
		ldi freq,No_key				;   
		out	OCR2,freq				;  
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		ldi R17,0xAF				; 
		rcall lcd_com				;   LCD
		ldi temp,0b00000101			;  1
		out TCCR1B,temp				;   1/1024
		
		; 
		clr r2						;  
		clr r8						;   
		clr r10						;  .  
		clr freq					;  
		clr temp3					;  R19
		
;-------------------- ----------------------------------------------
main: 			; 
		in temp,PINB				; 
		lsr temp					; 
		com temp					; 
		andi temp,0b00011011		;  
		push temp					;
		lsr temp					; 
		andi temp,0b00001100		; . 
		mov R1,temp					; . 
		pop temp					;
		andi temp,0b00000011		; . 
		or R1,temp					;  R1   
		;   ()
		DELAY 1						; 32  
		tst R2						;   ,
		breq main					;   
		
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		ldi R17,0xAF				; 
		rcall lcd_com				;   LCD
		ldi temp,0b00000101			;  1
		out TCCR1B,temp				;   1/1024
		
		; 
reg_V:	sbrc R2,0					;   V+
		rcall vol_up				;    
		sbrc R2,1					;   V-
		rcall vol_dw				;    
		sbrc R2,0					;   V+
		rjmp m_loop					;
		sbrc R2,1					;   V-
		rjmp m_loop					;
		
		;   
cnt_tm:	cp R1,R2					;  , 
		breq PC+2					;    -
		rjmp long					;
		inc R10						;    
		rjmp main					;
		
		;   
long:	mov temp,R10				;  
		cpi temp,45					;   -
		brmi ch_ch					;   .  ,
		rcall mode_s				;  -    
		
lng_ts:	tst R8						;  :
		breq hand					; -   
		
ch_ch:	;  
		sbrc R8,2					;   
		rjmp avto					;    
		sbrc R8,3					;   MP3-
		rjmp mp_play				;    MP3-
	 	rjmp hand					;, -    
		rjmp m_loop					;    
		
		;
avto:	sbrc R2,2					;   CH+
		rcall freq_Up				;    
		sbrc R2,3					;   CH-
		rcall freq_Down				;    
		rjmp m_loop					;
		
		;  
hand:	sbrc R2,2					;   CH+
		rcall St_Up					;     
		sbrc R2,3					;   CH-
		rcall St_Down				;     
		
m_loop: clr R2						;  
		clr R10						;  .  
		rjmp main					;   
		;
		
;===========================================================================
;			  MP3-
	;      R=1K (   R=2K)
	.equ Prev    = 14		;(52)    Prev/V--
	.equ PPMode  = 33		;(158)   P/P/Mode
	.equ Next    = 53		;(196)   Next/V++
	.equ Repeat  = 125		;(245)   Repeat
	.equ No_key  = 235		;(255)     
;---------------------------------------------------------------------------
mp_play:
		;  2 : fast PWM; F = 28,4 ;
		ldi temp,(1<<WGM21)|(1<<WGM20)|(1<<COM21)|(1<<CS20)		; 
;	ldi temp,(1<<WGM21)|(1<<WGM20)|(1<<COM21)|(1<<COM20)|(1<<CS20)	; 
		out	TCCR2,temp				;
		ldi temp,No_key				;   
		out	OCR2,temp				;
		sbi PORTD,PD6				;  MP3
		;   
		clr R2						;  
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg13*2		;.  Z  
		rcall Str_LCD				; . "3-"
		POZ_LCD 1,0					;1- , 0- 
		LOAD_ADDR Z,Messg18*2		;.  Z  
		rcall Str_LCD				; 
		POZ_LCD 3,0					;3- , 0- 
		LOAD_ADDR Z,Messg14*2		;.  Z  
		rcall Str_LCD				; . "V+:  Next"
		POZ_LCD 4,0					;4- , 0- 
		LOAD_ADDR Z,Messg15*2		;.  Z  
		rcall Str_LCD				; ."V-:  Prev"
		POZ_LCD 5,0					;5- , 0- 
		LOAD_ADDR Z,Messg16*2		;.  Z  
		rcall Str_LCD				; . "CH+: P/Mod"
		POZ_LCD 7,0					;7- , 0- 
		LOAD_ADDR Z,Messg17*2		;.  Z  
		rcall Str_LCD				; . "CH-: "
		
		; 
		ldi temp,0b00000011			;(02H) 0 = High impedance
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
play: 			; 
		in temp,PINB				; 
		lsr temp					; 
		com temp					; 
		andi temp,0b00011011		;  
		push temp					;
		lsr temp					; 
		andi temp,0b00001100		; . 
		mov R1,temp					; . 
		pop temp					;
		andi temp,0b00000011		; . 
		or R1,temp					;  R1   
		;   ()
		DELAY 1						; 32  
		tst R2						;   ,
		brne light					;
		ldi temp,No_key				;    
		out	OCR2,temp				;  
		cbi PORTD,PD7				; 
		breq play					;   
		
light:		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		ldi R17,0xAF				; 
		rcall lcd_com				;   LCD
		ldi temp,0b00000101			;  1
		out TCCR1B,temp				;   1/1024
		
		; 
p_cntr:	sbrc R2,0					;   Next/V++
		ldi temp,Next				;    
		sbrc R2,1					;   Prev/V--
		ldi temp,Prev				;    
		sbrc R2,2					;   P/P/Mode
		ldi temp,PPMode				;    
		sbrc R2,3					;   Repeat
		rjmp pl_rpt					;  
		out	OCR2,temp				;   
		sbi PORTD,PD7				; 
		rjmp p_loop					;    
		;  
pl_rpt:	rcall lcd_clr				; 
			; MP3-  
		cbi PORTD,PD6				;  MP3
		clr temp					;
		out	TCCR2,temp				; 
		clr R10						;
		clr R2						;  
		rjmp ms_dspl				;  
		
p_loop: clr R2						;  
		rjmp play					;   
		;
;===========================================================================
mode_s:		;   /
		clr R10						;  .  
		tst R8						;   
		brne rev					;
		mov R8,R2					;   
		rjmp rev_end				;
rev:	clr R8						;    
		
rev_end:clr temp					; temp    
 		ret
;===========================================================================
freq_Up: 	;   "+"   
		cli							; 
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
			;  ""
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; . ""
		
		rcall Mono					; ""
			;     
		ldi temp,0b10000011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		;	rjmp st_tn				;  
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
freq_Down:	;   "-"   
		cli							; 
		dec freq					; 
			;  ""
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; . ""
		
		rcall Mono					; ""
			;     
		ldi temp,0b10000001			;(02H) ., DMUTE=0,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
			;	rjmp st_tn				;  
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11000010			;(02H) ., DMUTE=1,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
 St_Up:			;     FLASH
 		cli
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
St_Down:	;     FLASH
		cli
 		ldi ZL,LOW((freq_st)*2)		;.  Z . ..
		ldi ZH,HIGH((freq_st)*2)	;
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp					;
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,12					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Print					;    
		rcall Prnt_F				;   
		;   
ch_st:	ldi temp,0b11000010			;(02H) ., DMUTE=1,,
									 ;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		rcall Mono					; ""
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:
		clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  ,
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,12					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;  . ". "
		rjmp Print					;  
		
na_ind:	adiw Z,1					;    
			;    
Print:	POZ_LCD 7,0					;7- ,0- 
		rcall Str_LCD				;    
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:		
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		inc YL						;
Rd_EEV:	sbic EECR,EEWE				;   
		rjmp Rd_EEV					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp,EEDR				;   . 
		andi temp,0x0F				;  
		sts volume,temp				;    
		sei
		
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 	
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0b00001000			;(04H) De-emphasis  1 = 50 s
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		tst temp					;  ,  -
		brpl PC+2					;
		ldi temp,0					;    
		ori temp,0b11000000			; .   
		rcall IIC_Send				;  
		
		ldi temp,0			 		;(06H)
		rcall IIC_Send				;
		ldi temp,0					;(06L)
		rcall IIC_Send				;
		
		ldi temp,0b01111100	 		;(07H)   
		rcall IIC_Send				;
		ldi temp,0					;(07L)
		rcall IIC_Send				;
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		rcall Wr_EEV				;   
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		ret
; ========================================================================
;		    ,  YH:YL   
;-------------------------------------------------------------------------
Wr_EEV:	cli
		ldi YL,LOW(Vol_EE)			;.  Y . ..
		clr YH						; .   
		lds temp,volume				;    
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		ret
; ========================================================================
		; 
vol_up:	cli
		clr R1				;
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_st			; ,  
		; 
		tst temp			;
		brpl PC+3			;   , 
		clr temp			;   ,
		rjmp PC+2			;   
		inc temp			;
		sts volume,temp		;  
vol_st:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
;========================================================================
		; 
vol_dw:	cli
		clr R1				;
		lds temp,volume		;    
		tst temp			;  .  < 0, 
		brmi PC+2			;   ,  -
		dec temp			;   
		sts volume,temp		;   
		tst temp			;   
		brpl vol_mi			;  .  < 0, 
		rcall mute			;    
		rcall type_vol		;   
		rjmp PC+2			;
		
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 320 
		clr temp			; temp    
		sei
		ret
		
;========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
mute:	cli
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
		
		ldi temp,0b10000010			;(02H): ., DMUTE=0,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		sei
		
		ret
; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli
		; 
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x02				;  (02H)  
		rcall IIC_Send				;  
			
		ldi temp,0b11000010			;(02H): ., DMUTE=1,,
		rcall IIC_Send				;SEEKUP=1, SEEK=0 ( )
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		rcall iic_stop 				;  ""
		;    
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei
		
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		cli
		POZ_LCD 0,11					;0- ,6- 
		
		lds temp,volume				;    
		tst temp					;  ,  -
		brpl PC+3					;
		clr temp					;      00,
		rjmp prbr					; , -  
		inc temp					;  1 
		
  prbr:		;   10- 
		clr R17						;
;		lds temp,volume				;    
		andi temp,0x1F				;  
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		sei
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		;    LCD
		POZ_LCD 0,2					;0- ,2- 
		
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
t_1:	tst R1				;     
		breq vyh			;   /,  -
		mov R2,R1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		push R17          	;   R19
    	in R17,SREG      	;
   		push R17         	;   SREG
		;
		dec R12				; 
		tst r12				;    , -
		brne wyh			;   /,  -
		
		ldi R17,0xAE		;(0xAE)	  ( )
		rcall lcd_com		;   LCD
		
		ldi R17,0			;  2
		out TCCR1B,R17		;
		;
wyh:	pop R17          	;   SREG
    	out SREG,R17     	;
    	pop R17          	;   R19
		
		reti
		
;===========================================================================
;		;      
;---------------------------------------------------------------------------
 Prnt_F:
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		ldi YL,LOW(decnum+3)	;.  X . .   
		clr YH					;
			;  
		;    LCD
		POZ_LCD 3,2				;2- ,0- 
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall D_twix			;  LCD 
		rjmp PC+2				
		
Fr_100:	rcall D_twix			;  
		
Fr_10:	ld temp,-Y				; .  
		rcall D_twix			;  
		
		ld temp,-Y				; .  
		rcall D_twix			;  
		
		;  LCD 
		ldI temp,0x0B			; 
		rcall D_twix			;   LCD 
		;   
		ld temp,-Y				; .  
		rcall D_twix			;   
		;  ""
		POZ_LCD 4,14			;4- ,14- 
		ldi ZL,LOW((Messg4)*2)	;   
		ldi ZH,HIGH((Messg4)*2)	;  ""
		rcall Str_LCD			;   
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	push R30					;
		push R31					;
		; . "  "   
		POZ_LCD 0,19				;0- ,9- 
		ldi temp,'M'				;
		rcall lcd_put_char			;  ""  LCD
		
		cbi PORTD,7					; 
		pop R31						;
		pop R30						;
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	push R30					;
		push R31					;
		; . ""   
		POZ_LCD 0,19				;0- ,9- 
		ldi temp,'S'				;
		rcall lcd_put_char			;  "S"  LCD
		
		sbi PORTD,7					; 
		pop R31						;
		pop R30						;
		ret

;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     ret

;=========================================================================

;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
	.include "Driver_SSD1306.asm"		; LCD SSD1306
 	.include "User_set.asm"				; 
;******************************************************************************
;===========================================================================
		;     
  Messg1: .DB  130,131,131,' ',142,' ',' ',' ',' ',' ', 0, 0		;. .
  Messg2: .DB  '','','','','','.',' ','','','', 0, 0
  
  Messg4: .DB  '','','',0
  Messg5: .DB  '','','','','','','','','',' ', 0, 0
  Messg6: .DB  131,131, 0, 0	; 0
  Messg7: .DB  132,131, 0, 0	; 1
  Messg8: .DB  133,131, 0, 0	; 2
  Messg9: .DB  133,134, 0, 0	; 3
  Messg10: .DB 133,135, 0, 0	; 4
  
  Messg11: .DB  ' ','','','','',' ', 0, 0
  Messg12: .DB  '','','','','','', 0, 0
  Messg13: .DB  'M','P','3','-','','','','','','',' ', 0, 0
  Messg14: .DB  'V','+',' ',' ','N','e','x','t',' ',' ', 0, 0
  Messg15: .DB  'V','-',' ',' ','P','r','e','v',' ',' ', 0, 0
  Messg16: .DB  'C','H','+',' ','P','/','M','o','d','e', 0, 0
  Messg17: .DB  'C','H','-',' ','R','a','d','i','o',' ', 0, 0
  Messg18: .DB  146,146,146,146,146,146,146,146,146,146, 0, 0
  

;=================================================================================

	.EXIT
	
